* gzexe.in: Work around FreeBSD shell trap bug.
[debian/gzip] / gzexe.in
1 #!/bin/sh
2 # gzexe: compressor for Unix executables.
3 # Use this only for binaries that you do not use frequently.
4 #
5 # The compressed version is a shell script which decompresses itself after
6 # skipping $skip lines of shell commands.  We try invoking the compressed
7 # executable with the original name (for programs looking at their name).
8 # We also try to retain the original file permissions on the compressed file.
9 # For safety reasons, gzexe will not create setuid or setgid shell scripts.
10
11 # WARNING: the first line of this file must be either : or #!/bin/sh
12 # The : is required for some old versions of csh.
13 # On Ultrix, /bin/sh is too buggy, change the first line to: #!/bin/sh5
14
15
16 # Copyright (C) 1998, 2002, 2004, 2006 Free Software Foundation
17 # Copyright (C) 1993 Jean-loup Gailly
18
19 # This program is free software; you can redistribute it and/or modify
20 # it under the terms of the GNU General Public License as published by
21 # the Free Software Foundation; either version 2 of the License, or
22 # (at your option) any later version.
23
24 # This program is distributed in the hope that it will be useful,
25 # but WITHOUT ANY WARRANTY; without even the implied warranty of
26 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
27 # GNU General Public License for more details.
28
29 # You should have received a copy of the GNU General Public License along
30 # with this program; if not, write to the Free Software Foundation, Inc.,
31 # 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301 USA.
32
33 tab='   '
34 nl='
35 '
36 IFS=" $tab$nl"
37
38 version='gzexe (gzip) @VERSION@
39 Copyright (C) 2006 Free Software Foundation, Inc.
40 This is free software.  You may redistribute copies of it under the terms of
41 the GNU General Public License <http://www.gnu.org/licenses/gpl.html>.
42 There is NO WARRANTY, to the extent permitted by law.
43
44 Written by Jean-loup Gailly.'
45
46 usage='Usage: gzexe [OPTION] FILE...
47 Rename each FILE with a compressed version of itself, renaming FILE to FILE~.
48
49   -d             Decompress each FILE instead of compressing it.
50       --help     display this help and exit
51       --version  output version information and exit
52
53 Report bugs to <bug-gzip@gnu.org>.'
54
55
56 PATH="BINDIR:$PATH"
57
58 decomp=0
59 res=0
60 while :; do
61   case $1 in
62   -d) decomp=1; shift;;
63   --h*) exec echo "$usage";;
64   --v*) exec echo "$version";;
65   --) shift; break;;
66   *) break;;
67   esac
68 done
69
70 if test $# -eq 0; then
71   echo >&2 "$0: missing operand
72 Try \`$0 --help' for more information."
73   exit 1
74 fi
75
76 tmp=
77 trap 'res=$?
78   test -n "$tmp" && rm -f "$tmp"
79   (exit $res); exit $res
80 ' 0 1 2 3 5 10 13 15
81
82 for i do
83   case $i in
84   -*) file=./$i;;
85   *)  file=$i;;
86   esac
87   if test ! -f "$file" || test ! -r "$file"; then
88     res=$?
89     echo >&2 "$0: $i is not a readable regular file"
90     continue
91   fi
92   if test $decomp -eq 0; then
93     if sed -e 1d -e 2q "$file" | grep "^skip=[0-9][0-9]*$" >/dev/null; then
94       echo >&2 "$0: $i is already gzexe'd"
95       continue
96     fi
97   fi
98   if test -u "$file"; then
99     echo >&2 "$0: $i has setuid permission, unchanged"
100     continue
101   fi
102   if test -g "$file"; then
103     echo >&2 "$0: $i has setgid permission, unchanged"
104     continue
105   fi
106   case /$file in
107   */basename | */cat | */chmod | */cp | \
108   */dirname | */echo | */expr | */gzip | \
109   */ln | */mkdir | */mktemp | */mv | */rm | */rmdir | \
110   */sed | */sh | */sleep | */test | */tail)
111     echo >&2 "$0: $i would depend on itself"; continue;;
112   esac
113
114   dir=`dirname "$file"` || dir=$TMPDIR
115   test -d "$dir" && test -w "$dir" && test -x "$dir" || dir=/tmp
116   test -n "$tmp" && rm -f "$tmp"
117   tmp=`TMPDIR=$dir mktemp -t gzexeXXXXXX` || tmp=$dir/gzexe$$
118   cp -p "$file" "$tmp" 2>/dev/null || cp "$file" "$tmp" || {
119     res=$?
120     echo >&2 "$0: cannot copy $file"
121     continue
122   }
123   if test -w "$tmp"; then
124     writable=1
125   else
126     writable=0
127     chmod u+w "$tmp" || {
128       res=$?
129       echo >&2 "$0: cannot chmod $tmp"
130       continue
131     }
132   fi
133   if test $decomp -eq 0; then
134     (cat <<'EOF' &&
135 #!/bin/sh
136 skip=43
137
138 tab='   '
139 nl='
140 '
141 IFS=" $tab$nl"
142
143 umask=`umask`
144 umask 77
145
146 gztmpdir=
147 trap 'res=$?
148   test -n "$gztmpdir" && rm -fr "$gztmpdir"
149   (exit $res); exit $res
150 ' 0 1 2 3 5 10 13 15
151
152 gztmpdir=`(mktemp -dt) 2>/dev/null` ||
153   { gztmpdir=/tmp/gztmp$$; mkdir $gztmpdir; } ||
154   { (exit 127); exit 127; }
155
156 gztmp=$gztmpdir/$0
157 case $0 in
158 -* | */*'
159 ') mkdir -p "$gztmp" && rmdir "$gztmp";;
160 */*) gztmp=$gztmpdir/`basename "$0"`;;
161 esac || { (exit 127); exit 127; }
162
163 case `echo X | tail -n +1 2>/dev/null` in
164 X) tail_n=-n;;
165 *) tail_n=;;
166 esac
167 if tail $tail_n +$skip <"$0" | gzip -cd > "$gztmp"; then
168   umask $umask
169   chmod 700 "$gztmp"
170   (sleep 5; rm -fr "$gztmpdir") 2>/dev/null &
171   "$gztmp" ${1+"$@"}; res=$?
172 else
173   echo >&2 "Cannot decompress $0"
174   (exit 127); res=127
175 fi; exit $res
176 EOF
177     gzip -cv9 "$file") > "$tmp" || {
178       res=$?
179       echo >&2 "$0: compression not possible for $i, file unchanged."
180       continue
181     }
182
183   else
184     # decompression
185     skip=43
186     skip_line=`sed -e 1d -e 2q "$file"`
187     case $skip_line in
188     skip=[0-9] | skip=[0-9][0-9] | skip=[0-9][0-9][0-9])
189       eval "$skip_line";;
190     esac
191     case `echo X | tail -n +1 2>/dev/null` in
192     X) tail_n=-n;;
193     *) tail_n=;;
194     esac
195     tail $tail_n +$skip "$file" | gzip -cd > "$tmp" || {
196       res=$?
197       echo >&2 "$0: $i probably not in gzexe format, file unchanged."
198       continue
199     }
200   fi
201   test $writable -eq 1 || chmod u-w "$tmp" || {
202     res=$?
203     echo >&2 "$0: $tmp: cannot chmod"
204     continue
205   }
206   ln -f "$file" "$file~" || {
207     res=$?
208     echo >&2 "$0: cannot backup $i as $i~"
209     continue
210   }
211   mv -f "$tmp" "$file" || {
212     res=$?
213     echo >&2 "$0: cannot rename $tmp to $i"
214     continue
215   }
216   tmp=
217 done
218 (exit $res); exit $res